/* som.c    main for som-language
	P. Chongstitvatana
	22 Oct 2002

	start Som project   			13 Sept 2003
	som v1  public release 			4 Dec 2004
	som-v15 rev2  seperate optim 	5 Mar 2005
	som-v16: hex, i-array, file i/o 6 Nov 2005
	som-v17 t-code					23 Dec 2005
	som-v24							1 Jan 2007 Happy New Year!

*/

#include "compile.h"

FILE *FO, *FI;			// output/input file
int load_ads;			// base ads for fun "loadfile"

extern int CP;

void seterror( char *mess ){
	fprintf(stderr,"Error : %s\n",mess);
	exit(-1);
}

PRIVATE char *stripdot(char *source){
	static char name[80];
	char *name2;
	strcpy(name,source);
	name2 = strtok(name,".");
	if( name2 == NULL ) name2 = name;
	return name2;
}

// make file.lst file.obj from file.xxx
PRIVATE void makename(char *nm){
	char *name;
	strpack(som_src,nm);
	name = stripdot(nm);
	strcat(name,".lst");
	strpack(som_lst,name);
	name = stripdot(nm);
	strcat(name,".obj");
	strpack(som_obj,name);
}

// read object file, code and data
PRIVATE void readobj(char *fn){
	int magic;
	FI = fopen(fn,"r");
	fscanf(FI,"%d",&magic);
	if(magic != OBJ_SOM16)
		seterror("not som-16 object");
	readCode(FI);
	readData(FI);
}

void doSom(void){
	int i, n, type, ref, arg, v;
	char name[NAMELEN];

	readobj("som0.obj");
	// read symtab, find "loadfile"
	fscanf(FI,"%d",&n);
	for(i=0; i<n; i++){
		fscanf(FI,"%s%d%d%d%d",name,&type,&ref,&arg,&v);
		if(eqs(name,"loadfile")) break;
	}
	if(i == n)
		seterror("not found loadfile");
	load_ads = CP;
	outa(icCall,ref);	// gen "call loadfile, end"
	outa(icEnd,0);
	fclose(FI);
	eval(1);
}

void Usage(void){
	printf("%s\n%s\n%s\n%s\n",
		"som          interactive mode",
		"som file     compile and run, output .lst and .obj",
		"som -x file  execute obj file",
		"som -?       this help");
	exit(0);
}

// mode 1 interactive, 2 compile&run, 3 execute
int main( int argc, char *argv[] ){
	int i, mode;
	mode = 2;
	for (i=1; i<argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case '?': Usage(); break;
			case 'x': mode = 3; break;
			default:
				fprintf(stderr,"unknown option %s\n",argv[i]);
				exit(0);
			}
		}else
			break;   // first non option, argv[i]
	}
	if(argc == 1) mode = 1;
	initfile();
	switch(mode){
	case 1:
		M[MODE_ADS] = 1;
		doSom();
		break;
	case 2:
		M[MODE_ADS] = 2;
		makename(argv[i]);
		doSom();
		break;
	case 3:
		readobj(argv[i]);
		fclose(FI);
		eval(1);
		break;
	}
	return 0;
}
